//
//  ViewController.swift
//  swift瀑布流
//
//  Created by yuan on 16/4/20.
//  Copyright © 2016年 yuan. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    var index : Int? = 0
    var flowLayout : RANFlowLayout?
    var collectionView : UICollectionView?
    var addMoreButton : UIButton?
    lazy var tempArray : NSMutableArray = {
        return NSMutableArray()
    }()
    lazy var dataArray : NSArray = {
        
        return getDataArray(self)()
    }()
    func getDataArray()->NSArray{
        let plistIndex = self.index! % 3 + 1
        let path = NSBundle.mainBundle().pathForResource("\(plistIndex).plist", ofType: nil)
        let dictArray = NSArray(contentsOfFile: path!)
        
        for dict in dictArray! {
            let model = RANModel().initWithDict(dict as! NSDictionary)
            tempArray.addObject(model)
        }
        return tempArray as NSArray
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        flowLayout = RANFlowLayout()
        collectionView = UICollectionView(frame: self.view.bounds, collectionViewLayout: flowLayout!)
        collectionView?.registerClass(RANCollectionViewCell.self, forCellWithReuseIdentifier: "RANCollectionViewCell")
        collectionView?.dataSource = self
        collectionView?.delegate = self
        collectionView?.backgroundColor = UIColor.brownColor()
        collectionView?.contentInset = UIEdgeInsetsMake(0, 0, 50, 0)
        view.addSubview(collectionView!)
        
        //传递相关数据
        //当前界面显示多少列
        flowLayout?.colCount = 3
        //把加载的数据传过去，得到宽高比
        flowLayout?.shops = self.dataArray
        
        
        
        initAddMoreButton()
        
    }
    func initAddMoreButton(){
        
        addMoreButton = UIButton(frame: CGRectMake(0, self.view.bounds.size.height - 44, self.view.bounds.size.width, 44))
        addMoreButton!.setTitle("加载更多", forState: UIControlState.Normal)
        addMoreButton!.addTarget(self, action: "addMoreButtonClick:", forControlEvents: UIControlEvents.TouchUpInside)
        addMoreButton!.backgroundColor = UIColor.greenColor()
        addMoreButton?.alpha = 0.0
        self.view.addSubview(addMoreButton!)
    }

    func addMoreButtonClick(button : UIButton){
        index = index! + 1
        button.enabled = false
        button.setTitle("正在加载", forState: UIControlState.Normal)
        let time = dispatch_time(DISPATCH_TIME_NOW, Int64(2 * Double(NSEC_PER_SEC)))
        //模拟网络请求  延时2秒加载数据
        dispatch_after(time, dispatch_get_main_queue()) { () -> Void in
            self.dataArray = self.getDataArray()
            self.collectionView?.reloadData()
            button.setTitle("加载更多", forState: UIControlState.Normal)
            button.enabled = true
            self.addMoreButton?.alpha = 0.0
        }
        
        
    }
    
    
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    


}
extension ViewController : UICollectionViewDataSource,UICollectionViewDelegate{
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int{
        return self.dataArray.count
    }
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell{
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("RANCollectionViewCell", forIndexPath: indexPath) as! RANCollectionViewCell
        cell.shops = self.dataArray[indexPath.item] as? RANModel
        return cell
    }
    func scrollViewDidScroll(scrollView: UIScrollView){
//        print(scrollView.contentOffset.y)
//        print(scrollView.contentSize)
//        print(self.view.bounds.size.height)
        let scrollH = scrollView.contentSize.height - self.view.bounds.size.height + 50
        let height = scrollH - scrollView.contentOffset.y
        print(height)
        if height <= 44 && height >= 0 {
            addMoreButton?.alpha = (CGFloat(44) - height) / CGFloat(44)
        }else if (height < 0){
            addMoreButton?.alpha = 1.0
        }else{
            addMoreButton?.alpha = 0.0
        }
    }
    
}

